/* autogenerated by embedmodel.py.  DO NOT EDIT */

#include <zebra.h>
#include "yang.h"

static const char model[] =
	"module frr-filter {\n"
	"  yang-version 1.1;\n"
	"  namespace \"http://frrouting.org/yang/filter\";\n"
	"  prefix frr-filter;\n"
	"\n"
	"  import ietf-inet-types {\n"
	"    prefix inet;\n"
	"  }\n"
	"  import ietf-yang-types {\n"
	"    prefix yang;\n"
	"  }\n"
	"\n"
	"  organization \"FRRouting\";\n"
	"  contact\n"
	"    \"FRR Users List:       <mailto:frog@lists.frrouting.org>\n"
	"     FRR Development List: <mailto:dev@lists.frrouting.org>\";\n"
	"  description\n"
	"    \"This module defines filter settings\n"
	"\n"
	"     Copyright 2020 FRRouting\n"
	"\n"
	"     Redistribution and use in source and binary forms, with or without\n"
	"     modification, are permitted provided that the following conditions\n"
	"     are met:\n"
	"\n"
	"     1. Redistributions of source code must retain the above copyright notice,\n"
	"     this list of conditions and the following disclaimer.\n"
	"\n"
	"     2. Redistributions in binary form must reproduce the above copyright\n"
	"     notice, this list of conditions and the following disclaimer in the\n"
	"     documentation and/or other materials provided with the distribution.\n"
	"\n"
	"     THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS\n"
	"     \\\"AS IS\\\" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT\n"
	"     LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR\n"
	"     A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT\n"
	"     HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,\n"
	"     SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT\n"
	"     LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,\n"
	"     DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY\n"
	"     THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT\n"
	"     (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE\n"
	"     OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.\";\n"
	"\n"
	"  revision 2019-07-04 {\n"
	"    description \"Initial revision\";\n"
	"  }\n"
	"\n"
	"  /*\n"
	"   * Types.\n"
	"   */\n"
	"  typedef access-list-standard {\n"
	"    description \"Standard IPv4 access list (any, host or a prefix)\";\n"
	"    type uint16 {\n"
	"      range \"1..99 | 1300..1999\";\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef access-list-extended {\n"
	"    description\n"
	"      \"Extended IPv4 access list (source / destination any, hosts or prefixes)\";\n"
	"    type uint16 {\n"
	"      range \"100..199 | 2000..2699\";\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef access-list-legacy {\n"
	"    description \"Standard/Extended IPv4 access list\";\n"
	"    type uint16 {\n"
	"      range \"1..199 | 1300..2699\";\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef access-list-name {\n"
	"    description \"Access list name formatting\";\n"
	"    type string;\n"
	"  }\n"
	"\n"
	"  typedef access-list-sequence {\n"
	"    description \"Access list sequence number\";\n"
	"    type uint32 {\n"
	"      range \"1..4294967295\";\n"
	"    }\n"
	"  }\n"
	"\n"
	"  typedef access-list-action {\n"
	"    description \"Access list return action on match\";\n"
	"    type enumeration {\n"
	"      enum deny {\n"
	"        description \"Deny an entry\";\n"
	"        value 0;\n"
	"      }\n"
	"      enum permit {\n"
	"        description \"Accept an entry\";\n"
	"        value 1;\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"\n"
	"  /*\n"
	"   * Configuration data.\n"
	"   */\n"
	"  container filter-list {\n"
	"    list access-list-legacy {\n"
	"      description \"Access list legacy instance\";\n"
	"\n"
	"      key \"number sequence\";\n"
	"\n"
	"      leaf number {\n"
	"        description \"Access list sequence value\";\n"
	"        type access-list-legacy;\n"
	"      }\n"
	"\n"
	"      leaf sequence {\n"
	"        description \"Access list sequence value\";\n"
	"        type access-list-sequence;\n"
	"      }\n"
	"\n"
	"      leaf action {\n"
	"        description \"Access list action on match\";\n"
	"        type access-list-action;\n"
	"        mandatory true;\n"
	"      }\n"
	"\n"
	"      leaf remark {\n"
	"        description \"Access list remark\";\n"
	"        type string;\n"
	"      }\n"
	"\n"
	"      choice value {\n"
	"        description\n"
	"          \"Standard access list: value to match.\n"
	"           Extended access list: source value to match.\";\n"
	"        mandatory true;\n"
	"\n"
	"        leaf host {\n"
	"          description \"Host to match\";\n"
	"          type inet:ipv4-address;\n"
	"        }\n"
	"        leaf network {\n"
	"          description \"Network to match\";\n"
	"          type inet:ipv4-prefix;\n"
	"        }\n"
	"        leaf any {\n"
	"          description \"Match any\";\n"
	"          type empty;\n"
	"        }\n"
	"      }\n"
	"\n"
	"      choice extended-value {\n"
	"        when \"./sequence >= 100 and ./sequence <= 199 or\n"
	"              ./sequence >= 2000 and ./sequence <= 2699\";\n"
	"        description \"Destination value to match\";\n"
	"\n"
	"        leaf destination-host {\n"
	"          description \"Host to match\";\n"
	"          type inet:ipv4-address;\n"
	"        }\n"
	"        leaf destination-network {\n"
	"          description \"Network to match\";\n"
	"          type inet:ipv4-prefix;\n"
	"        }\n"
	"        leaf destination-any {\n"
	"          description \"Match any\";\n"
	"          type empty;\n"
	"        }\n"
	"      }\n"
	"    }\n"
	"\n"
	"    list access-list {\n"
	"      description \"Access list instance\";\n"
	"\n"
	"      key \"type identifier sequence\";\n"
	"\n"
	"      leaf type {\n"
	"        description \"Access list content type\";\n"
	"        type enumeration {\n"
	"          enum ipv4 {\n"
	"            description \"Internet Protocol address version 4\";\n"
	"            value 0;\n"
	"          }\n"
	"          enum ipv6 {\n"
	"            description \"Internet Protocol address version 6\";\n"
	"            value 1;\n"
	"          }\n"
	"          enum mac {\n"
	"            description \"Media Access Control address\";\n"
	"            value 2;\n"
	"          }\n"
	"\n"
	"          /*\n"
	"           * Protocol YANG models should augment the parent node to\n"
	"           * contain the routing protocol specific value. The protocol\n"
	"           * must also augment `value` leaf to include its specific\n"
	"           * values or expand the `when` statement on the existing cases.\n"
	"           */\n"
	"          enum custom {\n"
	"            description \"Custom data type\";\n"
	"            value 100;\n"
	"          }\n"
	"        }\n"
	"      }\n"
	"\n"
	"      leaf identifier {\n"
	"        description \"Access list identifier\";\n"
	"        type access-list-name;\n"
	"      }\n"
	"\n"
	"      leaf sequence {\n"
	"        description \"Access list sequence value\";\n"
	"        type access-list-sequence;\n"
	"      }\n"
	"\n"
	"      leaf action {\n"
	"        description \"Access list action on match\";\n"
	"        type access-list-action;\n"
	"        mandatory true;\n"
	"      }\n"
	"\n"
	"      leaf remark {\n"
	"        description \"Access list remark\";\n"
	"        type string;\n"
	"      }\n"
	"\n"
	"      choice value {\n"
	"        description \"Access list value to match\";\n"
	"        mandatory true;\n"
	"\n"
	"        case ipv4-prefix {\n"
	"          when \"./type = \'ipv4\'\";\n"
	"\n"
	"          leaf ipv4-prefix {\n"
	"            description \"Configure IPv4 prefix to match\";\n"
	"            type inet:ipv4-prefix;\n"
	"          }\n"
	"\n"
	"          leaf ipv4-exact-match {\n"
	"            description \"Exact match of prefix\";\n"
	"            type boolean;\n"
	"            default false;\n"
	"          }\n"
	"        }\n"
	"        case ipv6-prefix {\n"
	"          when \"./type = \'ipv6\'\";\n"
	"\n"
	"          leaf ipv6-prefix {\n"
	"            description \"Configure IPv6 prefix to match\";\n"
	"            type inet:ipv6-prefix;\n"
	"          }\n"
	"\n"
	"          leaf ipv6-exact-match {\n"
	"            description \"Exact match of prefix\";\n"
	"            type boolean;\n"
	"            default false;\n"
	"          }\n"
	"        }\n"
	"        case mac {\n"
	"          when \"./type = \'mac\'\";\n"
	"\n"
	"          leaf mac {\n"
	"            description \"Configure MAC address to match\";\n"
	"            type yang:mac-address;\n"
	"          }\n"
	"        }\n"
	"        case any {\n"
	"          leaf any {\n"
	"            description \"Match anything\";\n"
	"            type empty;\n"
	"          }\n"
	"        }\n"
	"      }\n"
	"    }\n"
	"\n"
	"    list prefix-list {\n"
	"      description \"Prefix list instance\";\n"
	"\n"
	"      key \"type name sequence\";\n"
	"\n"
	"      leaf type {\n"
	"        description \"Prefix list type\";\n"
	"        type enumeration {\n"
	"          enum ipv4 {\n"
	"            description \"Internet Protocol address version 4\";\n"
	"            value 0;\n"
	"          }\n"
	"          enum ipv6 {\n"
	"            description \"Internet Protocol address version 6\";\n"
	"            value 1;\n"
	"          }\n"
	"        }\n"
	"      }\n"
	"\n"
	"      leaf name {\n"
	"        description \"Prefix list name\";\n"
	"        type access-list-name;\n"
	"      }\n"
	"\n"
	"      leaf sequence {\n"
	"        description \"Access list sequence value\";\n"
	"        type access-list-sequence;\n"
	"      }\n"
	"\n"
	"      leaf action {\n"
	"        description \"Prefix list action on match\";\n"
	"        type access-list-action;\n"
	"        mandatory true;\n"
	"      }\n"
	"\n"
	"      leaf description {\n"
	"        description \"Prefix list user description\";\n"
	"        type string;\n"
	"      }\n"
	"\n"
	"      choice value {\n"
	"        description \"Prefix list value to match\";\n"
	"        mandatory true;\n"
	"\n"
	"        case ipv4-prefix {\n"
	"          when \"./type = \'ipv4\'\";\n"
	"\n"
	"          leaf ipv4-prefix {\n"
	"            description \"Configure IPv4 prefix to match\";\n"
	"            type inet:ipv4-prefix;\n"
	"          }\n"
	"\n"
	"          leaf ipv4-prefix-length-greater-or-equal {\n"
	"            description\n"
	"              \"Specifies if matching prefixes with length greater than\n"
	"               or equal to value\";\n"
	"            type uint8 {\n"
	"              range \"0..32\";\n"
	"            }\n"
	"          }\n"
	"\n"
	"          leaf ipv4-prefix-length-lesser-or-equal {\n"
	"            description\n"
	"              \"Specifies if matching prefixes with length lesser than\n"
	"               or equal to value\";\n"
	"            type uint8 {\n"
	"              range \"0..32\";\n"
	"            }\n"
	"          }\n"
	"        }\n"
	"        case ipv6-prefix {\n"
	"          when \"./type = \'ipv6\'\";\n"
	"\n"
	"          leaf ipv6-prefix {\n"
	"            description \"Configure IPv6 prefix to match\";\n"
	"            type inet:ipv6-prefix;\n"
	"          }\n"
	"\n"
	"          leaf ipv6-prefix-length-greater-or-equal {\n"
	"            description\n"
	"              \"Specifies if matching prefixes with length greater than\n"
	"               or equal to value\";\n"
	"            type uint8 {\n"
	"              range \"0..128\";\n"
	"            }\n"
	"          }\n"
	"\n"
	"          leaf ipv6-prefix-length-lesser-or-equal {\n"
	"            description\n"
	"              \"Specifies if matching prefixes with length lesser than\n"
	"               or equal to value\";\n"
	"            type uint8 {\n"
	"              range \"0..128\";\n"
	"            }\n"
	"          }\n"
	"        }\n"
	"        case any {\n"
	"          leaf any {\n"
	"            description \"Match anything\";\n"
	"            type empty;\n"
	"          }\n"
	"        }\n"
	"      }\n"
	"    }\n"
	"  }\n"
	"}\n"
	"";

static struct yang_module_embed embed = {
	.mod_name = "frr-filter",
	.mod_rev = "2019-07-04",
	.data = model,
	.format = LYS_YANG,
};

static void embed_register(void) __attribute__((_CONSTRUCTOR(2000)));
static void embed_register(void)
{
	yang_module_embed(&embed);
}
